/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.1 Revision 1.86
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.1 2004/11/24 16:36:38 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.86 2010/08/05 21:57:53 robbat2 Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Original author: John Mylchreest <johnm@gentoo.org>
6# source version, selected kernel options etc. 6# Maintainer: kernel-misc@gentoo.org
7# 7#
8# Please direct your bugs to the current eclass maintainer :)
8 9
9ECLASS=linux-info 10# @ECLASS: linux-info.eclass
10INHERITED="$INHERITED $ECLASS" 11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
24
25# A Couple of env vars are available to effect usage of this eclass
26# These are as follows:
27
28# @ECLASS-VARIABLE: KERNEL_DIR
29# @DESCRIPTION:
30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
35# A string containing a list of .config options to check for before
36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
40# You can also check that an option doesn't exist by
41# prepending it with an exclamation mark (!).
42#
43# e.g.: CONFIG_CHECK="!MTRR"
44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
59#
60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
61
62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
65# which is to be used as the kernel object directory.
66
67# There are also a couple of variables which are set by this, and shouldn't be
68# set by hand. These are as follows:
69
70# @ECLASS-VARIABLE: KV_FULL
71# @DESCRIPTION:
72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
73
74# @ECLASS-VARIABLE: KV_MAJOR
75# @DESCRIPTION:
76# A read-only variable. It's an integer containing the kernel major version. ie: 2
77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
97# KERNEL_DIR is invalid.
98
99# @ECLASS-VARIABLE: KV_OUT_DIR
100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# And to ensure all the weirdness with crosscompile
105inherit toolchain-funcs versionator
106
107EXPORT_FUNCTIONS pkg_setup
108
109DEPEND=""
110RDEPEND=""
11 111
12# Overwritable environment Var's 112# Overwritable environment Var's
13# --------------------------------------- 113# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 114KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
15 115
16 116
117# Bug fixes
118# fix to bug #75034
119case ${ARCH} in
120 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
121 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
122esac
123
124# @FUNCTION: set_arch_to_kernel
125# @DESCRIPTION:
126# Set the env ARCH to match what the kernel expects.
127set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
128# @FUNCTION: set_arch_to_portage
129# @DESCRIPTION:
130# Set the env ARCH to match what portage expects.
131set_arch_to_portage() { export ARCH=$(tc-arch); }
132
133# qeinfo "Message"
134# -------------------
135# qeinfo is a quiet einfo call when EBUILD_PHASE
136# should not have visible output.
137qout() {
138 local outputmsg type
139 type=${1}
140 shift
141 outputmsg="${@}"
142 case "${EBUILD_PHASE}" in
143 depend) unset outputmsg;;
144 clean) unset outputmsg;;
145 preinst) unset outputmsg;;
146 esac
147 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
148}
149
150qeinfo() { qout einfo "${@}" ; }
151qewarn() { qout ewarn "${@}" ; }
152qeerror() { qout eerror "${@}" ; }
17 153
18# File Functions 154# File Functions
19# --------------------------------------- 155# ---------------------------------------
20 156
21# getfilevar accepts 2 vars as follows: 157# @FUNCTION: getfilevar
22# getfilevar <VARIABLE> <CONFIGFILE> 158# @USAGE: variable configfile
23 159# @RETURN: the value of the variable
160# @DESCRIPTION:
161# It detects the value of the variable defined in the file configfile. This is
162# done by including the configfile, and printing the variable with Make.
163# It WILL break if your makefile has missing dependencies!
24getfilevar() { 164getfilevar() {
25local ERROR 165local ERROR basefname basedname myARCH="${ARCH}"
26 ERROR=0 166 ERROR=0
27 167
28 [ -z "${1}" ] && ERROR=1 168 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 169 [ ! -f "${2}" ] && ERROR=1
31 170
32 if [ "${ERROR}" = 1 ] 171 if [ "${ERROR}" = 1 ]
33 then 172 then
173 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 174 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 175 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 176 else
37 grep -e "^$1" $2 | sed 's: = :=:' | cut -d= -f2- 177 basefname="$(basename ${2})"
38 fi 178 basedname="$(dirname ${2})"
39} 179 unset ARCH
40 180
181 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
182 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
183
184 ARCH=${myARCH}
185 fi
186}
187
188# @FUNCTION: getfilevar_noexec
189# @USAGE: variable configfile
190# @RETURN: the value of the variable
191# @DESCRIPTION:
192# It detects the value of the variable defined in the file configfile.
193# This is done with sed matching an expression only. If the variable is defined,
194# you will run into problems. See getfilevar for those cases.
41getfilevar_isset() { 195getfilevar_noexec() {
196 local ERROR basefname basedname mycat myARCH="${ARCH}"
197 ERROR=0
198 mycat='cat'
199
200 [ -z "${1}" ] && ERROR=1
201 [ ! -f "${2}" ] && ERROR=1
202 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
203
204 if [ "${ERROR}" = 1 ]
205 then
206 echo -e "\n"
207 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
208 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
209 else
210 ${mycat} "${2}" | \
211 sed -n \
212 -e "/^[[:space:]]*${1}[[:space:]]*:\\?=[[:space:]]*\(.*\)\$/{
213 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
214 s,[[:space:]]*\$,,g ;
215 p
216 }"
217 fi
218}
219
220# @PRIVATE-VARIABLE: _LINUX_CONFIG_EXISTS_DONE
221# @DESCRIPTION:
222# This is only set if one of the linux_config_*exists functions has been called.
223# We use it for a QA warning that the check for a config has not been performed,
224# as linux_chkconfig* in non-legacy mode WILL return an undefined value if no
225# config is available at all.
226_LINUX_CONFIG_EXISTS_DONE=
227
228linux_config_qa_check() {
229 local f="$1"
230 if [ -z "${_LINUX_CONFIG_EXISTS_DONE}" ]; then
231 ewarn "QA: You called $f before any linux_config_exists!"
232 ewarn "QA: The return value of $f will NOT gaurenteed later!"
233 fi
234}
235
236# @FUNCTION: linux_config_src_exists
237# @RETURN: true or false
238# @DESCRIPTION:
239# It returns true if .config exists in a build directory otherwise false
240linux_config_src_exists() {
241 export _LINUX_CONFIG_EXISTS_DONE=1
242 [ -s "${KV_OUT_DIR}/.config" ]
243}
244
245# @FUNCTION: linux_config_bin_exists
246# @RETURN: true or false
247# @DESCRIPTION:
248# It returns true if .config exists in /proc, otherwise false
249linux_config_bin_exists() {
250 export _LINUX_CONFIG_EXISTS_DONE=1
251 [ -s "/proc/config.gz" ]
252}
253
254# @FUNCTION: linux_config_exists
255# @RETURN: true or false
256# @DESCRIPTION:
257# It returns true if .config exists otherwise false
258#
259# This function MUST be checked before using any of the linux_chkconfig_*
260# functions.
261linux_config_exists() {
262 linux_config_src_exists || linux_config_bin_exists
263}
264
265# @FUNCTION: require_configured_kernel
266# @DESCRIPTION:
267# This function verifies that the current kernel is configured (it checks against the existence of .config)
268# otherwise it dies.
269require_configured_kernel() {
270 if ! linux_config_src_exists; then
271 qeerror "Could not find a usable .config in the kernel source directory."
272 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
273 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
274 qeerror "it points to the necessary object directory so that it might find .config."
275 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
276 fi
277}
278
279# @FUNCTION: linux_chkconfig_present
280# @USAGE: option
281# @RETURN: true or false
282# @DESCRIPTION:
283# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
284# If linux_config_exists returns false, the results of this are UNDEFINED. You
285# MUST call linux_config_exists first.
286linux_chkconfig_present() {
287 linux_config_qa_check linux_chkconfig_present
42local RESULT 288 local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 289 local config
290 config="${KV_OUT_DIR}/.config"
291 [ ! -f "${config}" ] && config="/proc/config.gz"
292 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 293 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 294}
46 295
47getfilevar_ismodule() { 296# @FUNCTION: linux_chkconfig_module
297# @USAGE: option
298# @RETURN: true or false
299# @DESCRIPTION:
300# It checks that CONFIG_<option>=m is present in the current kernel .config
301# If linux_config_exists returns false, the results of this are UNDEFINED. You
302# MUST call linux_config_exists first.
303linux_chkconfig_module() {
304 linux_config_qa_check linux_chkconfig_module
48local RESULT 305 local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 306 local config
307 config="${KV_OUT_DIR}/.config"
308 [ ! -f "${config}" ] && config="/proc/config.gz"
309 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 310 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 311}
52 312
53getfilevar_isbuiltin() { 313# @FUNCTION: linux_chkconfig_builtin
314# @USAGE: option
315# @RETURN: true or false
316# @DESCRIPTION:
317# It checks that CONFIG_<option>=y is present in the current kernel .config
318# If linux_config_exists returns false, the results of this are UNDEFINED. You
319# MUST call linux_config_exists first.
320linux_chkconfig_builtin() {
321 linux_config_qa_check linux_chkconfig_builtin
54local RESULT 322 local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 323 local config
324 config="${KV_OUT_DIR}/.config"
325 [ ! -f "${config}" ] && config="/proc/config.gz"
326 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 327 [ "${RESULT}" = "y" ] && return 0 || return 1
328}
329
330# @FUNCTION: linux_chkconfig_string
331# @USAGE: option
332# @RETURN: CONFIG_<option>
333# @DESCRIPTION:
334# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
335# If linux_config_exists returns false, the results of this are UNDEFINED. You
336# MUST call linux_config_exists first.
337linux_chkconfig_string() {
338 linux_config_qa_check linux_chkconfig_string
339 local config
340 config="${KV_OUT_DIR}/.config"
341 [ ! -f "${config}" ] && config="/proc/config.gz"
342 getfilevar_noexec "CONFIG_${1}" "${config}"
57} 343}
58 344
59# Versioning Functions 345# Versioning Functions
60# --------------------------------------- 346# ---------------------------------------
61 347
62# kernel_is returns true when the version is the same as the passed version 348# @FUNCTION: kernel_is
349# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
350# @RETURN: true or false
351# @DESCRIPTION:
352# It returns true when the current kernel version satisfies the comparison against the passed version.
353# -eq is the default comparison.
63# 354#
355# @CODE
64# For Example where KV = 2.6.9 356# For Example where KV = 2.6.9
65# kernel_is 2 4 returns false 357# kernel_is 2 4 returns false
66# kernel_is 2 returns true 358# kernel_is 2 returns true
67# kernel_is 2 6 returns true 359# kernel_is 2 6 returns true
68# kernel_is 2 6 8 returns false 360# kernel_is 2 6 8 returns false
69# kernel_is 2 6 9 returns true 361# kernel_is 2 6 9 returns true
70# 362# @CODE
363
71# got the jist yet? 364# got the jist yet?
72 365
73kernel_is() { 366kernel_is() {
74 # if we haven't determined the version yet, we need too. 367 # if we haven't determined the version yet, we need to.
75 get_version; 368 linux-info_get_any_version
76
77 local RESULT
78 RESULT=1
79
80 if [ -n "${1}" ]
81 then
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0
83 fi
84
85 if [ -n "${2}" ]
86 then
87 RESULT=1
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0
89 fi
90
91 if [ -n "${3}" ]
92 then
93 RESULT=1
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0
95 fi
96 return ${RESULT}
97}
98 369
370 local operator testagainst value x=0 y=0 z=0
371
372 case ${1} in
373 -lt|lt) operator="-lt"; shift;;
374 -gt|gt) operator="-gt"; shift;;
375 -le|le) operator="-le"; shift;;
376 -ge|ge) operator="-ge"; shift;;
377 -eq|eq) operator="-eq"; shift;;
378 *) operator="-eq";;
379 esac
380
381 for x in ${@}; do
382 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
383 value="${value}${x}"
384 z=$((${z} + 1))
385
386 case ${z} in
387 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do testagainst="${testagainst}0"; done;
388 testagainst="${testagainst}${KV_MAJOR}";;
389 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do testagainst="${testagainst}0"; done;
390 testagainst="${testagainst}${KV_MINOR}";;
391 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do testagainst="${testagainst}0"; done;
392 testagainst="${testagainst}${KV_PATCH}";;
393 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
394 esac
395 done
396
397 [ "${testagainst}" ${operator} "${value}" ] && return 0 || return 1
398}
399
400get_localversion() {
401 local lv_list i x
402
403 # ignore files with ~ in it.
404 for i in $(ls ${1}/localversion* 2>/dev/null); do
405 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
406 done
407
408 for i in ${lv_list}; do
409 x="${x}$(<${i})"
410 done
411 x=${x/ /}
412 echo ${x}
413}
414
415# Check if the Makefile is valid for direct parsing.
416# Check status results:
417# - PASS, use 'getfilevar' to extract values
418# - FAIL, use 'getfilevar_noexec' to extract values
419# The check may fail if:
420# - make is not present
421# - corruption exists in the kernel makefile
422get_makefile_extract_function() {
423 local a='' b='' mkfunc='getfilevar'
424 a="$(getfilevar VERSION ${KERNEL_MAKEFILE})"
425 b="$(getfilevar_noexec VERSION ${KERNEL_MAKEFILE})"
426 [[ "${a}" != "${b}" ]] && mkfunc='getfilevar_noexec'
427 echo "${mkfunc}"
428}
429
430# internal variable, so we know to only print the warning once
431get_version_warning_done=
432
433# @FUNCTION: get_version
434# @DESCRIPTION:
435# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
436# (if KV_FULL is already set it does nothing).
437#
438# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
439#
440# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
441# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
442# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
99get_version() { 443get_version() {
444 local kbuild_output mkfunc tmplocal
445
100 # no need to execute this twice assuming KV_FULL is populated. 446 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 447 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 448 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 449
109 # if we dont know KV_FULL, then we need too. 450 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 451 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 452 unset KV_DIR
112 453
113 # KV_DIR will contain the full path to the sources directory we should use 454 # KV_DIR will contain the full path to the sources directory we should use
455 [ -z "${get_version_warning_done}" ] && \
114 einfo "Determining the location of the kernel source code" 456 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 457 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 458 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 459
118 if [ -z "${KV_DIR}" ] 460 if [ -z "${KV_DIR}" ]
119 then 461 then
462 if [ -z "${get_version_warning_done}" ]; then
463 get_version_warning_done=1
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 464 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 465 #qeinfo "This package requires Linux sources."
466 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
467 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
468 qeinfo "(or the kernel you wish to build against)."
469 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
470 else
471 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
472 fi
122 fi 473 fi
474 return 1
475 fi
476
477 if [ -z "${get_version_warning_done}" ]; then
478 qeinfo "Found kernel source directory:"
479 qeinfo " ${KV_DIR}"
480 fi
481
482 if [ ! -s "${KV_DIR}/Makefile" ]
483 then
484 if [ -z "${get_version_warning_done}" ]; then
485 get_version_warning_done=1
486 qeerror "Could not find a Makefile in the kernel source directory."
487 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
488 fi
489 return 1
490 fi
491
492 # OK so now we know our sources directory, but they might be using
493 # KBUILD_OUTPUT, and we need this for .config and localversions-*
494 # so we better find it eh?
495 # do we pass KBUILD_OUTPUT on the CLI?
496 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
497
498 # keep track of it
499 KERNEL_MAKEFILE="${KV_DIR}/Makefile"
123 500
501 # Decide the function used to extract makefile variables.
502 mkfunc="$(get_makefile_extract_function "${KERNEL_MAKEFILE}")"
503
504 # And if we didn't pass it, we can take a nosey in the Makefile
505 kbuild_output="$(${mkfunc} KBUILD_OUTPUT ${KERNEL_MAKEFILE})"
506 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
507
124 # And contrary to existing functions I feel we shouldn't trust the 508 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 509 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 510 # so we parse ${KERNEL_MAKEFILE}
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 511 KV_MAJOR="$(${mkfunc} VERSION ${KERNEL_MAKEFILE})"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 512 KV_MINOR="$(${mkfunc} PATCHLEVEL ${KERNEL_MAKEFILE})"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 513 KV_PATCH="$(${mkfunc} SUBLEVEL ${KERNEL_MAKEFILE})"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 514 KV_EXTRA="$(${mkfunc} EXTRAVERSION ${KERNEL_MAKEFILE})"
515
516 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
517 then
518 if [ -z "${get_version_warning_done}" ]; then
519 get_version_warning_done=1
520 qeerror "Could not detect kernel version."
521 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
522 fi
523 return 1
524 fi
525
131 # and in newer versions we can also pull LOCALVERSION if it is set. 526 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 527 # but before we do this, we need to find if we use a different object directory.
133 528 # This *WILL* break if the user is using localversions, but we assume it was
529 # caught before this if they are.
530 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
531
532 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
533 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
534 if [ -n "${KV_OUT_DIR}" ];
535 then
536 qeinfo "Found kernel object directory:"
537 qeinfo " ${KV_OUT_DIR}"
538 fi
539 # and if we STILL have not got it, then we better just set it to KV_DIR
540 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
541
542 # Grab the kernel release from the output directory.
543 # TODO: we MUST detect kernel.release being out of date, and 'return 1' from
544 # this function.
545 if [ -s "${KV_OUT_DIR}"/include/config/kernel.release ]; then
546 KV_LOCAL=$(<"${KV_OUT_DIR}"/include/config/kernel.release)
547 elif [ -s "${KV_OUT_DIR}"/.kernelrelease ]; then
548 KV_LOCAL=$(<"${KV_OUT_DIR}"/.kernelrelease)
549 else
550 KV_LOCAL=
551 fi
552
553 # KV_LOCAL currently contains the full release; discard the first bits.
554 tmplocal=${KV_LOCAL#${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}}
555
556 # If the updated local version was not changed, the tree is not prepared.
557 # Clear out KV_LOCAL in that case.
558 # TODO: this does not detect a change in the localversion part between
559 # kernel.release and the value that would be generated.
560 if [ "$KV_LOCAL" = "$tmplocal" ]; then
561 KV_LOCAL=
562 else
563 KV_LOCAL=$tmplocal
564 fi
565
134 # And we should set KV_FULL to the full expanded version 566 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 567 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 568
137 if [ -z "${KV_FULL}" ] 569 qeinfo "Found sources for kernel version:"
138 then 570 qeinfo " ${KV_FULL}"
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}" 571
140 eerror "Please check a kernel source exists in this directory." 572 return 0
141 die 573}
574
575# @FUNCTION: get_running_version
576# @DESCRIPTION:
577# It gets the version of the current running kernel and the result is the same as get_version() if the
578# function can find the sources.
579get_running_version() {
580 KV_FULL=$(uname -r)
581
582 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile && -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
583 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
584 KBUILD_OUTPUT=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
585 unset KV_FULL
586 get_version
587 return $?
588 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
589 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
590 unset KV_FULL
591 get_version
592 return $?
593 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
594 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
595 unset KV_FULL
596 get_version
597 return $?
142 else 598 else
143 einfo "Found kernel source directory:" 599 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
144 einfo " ${KV_DIR}" 600 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
145 einfo "with sources for kernel version:" 601 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
146 einfo " ${KV_FULL}" 602 KV_PATCH=${KV_PATCH//-*}
603 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
604 && KV_EXTRA="-${KV_FULL#*-}"
147 fi 605 fi
606 return 0
148} 607}
149 608
609# This next function is named with the eclass prefix to avoid conflicts with
610# some old versionator-like eclass functions.
150 611
612# @FUNCTION: linux-info_get_any_version
613# @DESCRIPTION:
614# This attempts to find the version of the sources, and otherwise falls back to
615# the version of the running kernel.
616linux-info_get_any_version() {
617 get_version
618 if [[ $? -ne 0 ]]; then
619 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
620 get_running_version
621 fi
622}
151 623
152 624
153# ebuild check functions 625# ebuild check functions
154# --------------------------------------- 626# ---------------------------------------
155 627
628# @FUNCTION: check_kernel_built
629# @DESCRIPTION:
630# This function verifies that the current kernel sources have been already prepared otherwise it dies.
156check_kernel_built() { 631check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 632 # if we haven't determined the version yet, we need to
633 require_configured_kernel
158 get_version; 634 get_version
159 635
160 if [ ! -f "${KV_DIR}/System.map" ] 636 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 637 then
162 eerror "These sources have not yet been compiled." 638 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 639 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 640 eerror "To resolve this, please type the following:"
165 eerror 641 eerror
166 eerror "# cd ${KV_DIR}" 642 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 643 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 644 eerror "# make modules_prepare"
169 eerror 645 eerror
170 eerror "Then please try merging this module again." 646 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 647 die "Kernel sources need compiling first"
172 fi 648 fi
173} 649}
174 650
651# @FUNCTION: check_modules_supported
652# @DESCRIPTION:
653# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
175check_modules_supported() { 654check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 655 # if we haven't determined the version yet, we need too.
656 require_configured_kernel
177 get_version; 657 get_version
178 658
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 659 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 660 then
182 eerror "These sources do not support loading external modules." 661 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 662 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 663 eerror "in your kernel, recompile and then try merging this module again."
664 die "No support for external modules in ${KV_FULL} config"
665 fi
666}
667
668# @FUNCTION: check_extra_config
669# @DESCRIPTION:
670# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
671# the prefix ~ is not used) doesn't satisfy the directive.
672check_extra_config() {
673 local config negate die error reworkmodulenames
674 local soft_errors_count=0 hard_errors_count=0 config_required=0
675 # store the value of the QA check, because otherwise we won't catch usages
676 # after if check_extra_config is called AND other direct calls are done
677 # later.
678 local old_LINUX_CONFIG_EXISTS_DONE="${_LINUX_CONFIG_EXISTS_DONE}"
679
680 # if we haven't determined the version yet, we need to
681 linux-info_get_any_version
682
683 # Determine if we really need a .config. The only time when we don't need
684 # one is when all of the CONFIG_CHECK options are prefixed with "~".
685 for config in ${CONFIG_CHECK}
686 do
687 if [[ "${config:0:1}" != "~" ]]; then
688 config_required=1
689 break
185 fi 690 fi
691 done
692
693 if [[ ${config_required} == 0 ]]; then
694 # In the case where we don't require a .config, we can now bail out
695 # if the user has no .config as there is nothing to do. Otherwise
696 # code later will cause a failure due to missing .config.
697 if ! linux_config_exists; then
698 ewarn "Unable to check for the following kernel config options due"
699 ewarn "to absence of any configured kernel sources or compiled"
700 ewarn "config:"
701 for config in ${CONFIG_CHECK}; do
702 local_error="ERROR_${config#\~}"
703 msg="${!local_error}"
704 if [[ "x${msg}" == "x" ]]; then
705 local_error="WARNING_${config#\~}"
706 msg="${!local_error}"
707 fi
708 ewarn " - ${config#\~}${msg:+ - }${msg}"
709 done
710 ewarn "You're on your own to make sure they are set if needed."
711 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
712 return 0
713 fi
714 else
715 require_configured_kernel
716 fi
717
718 einfo "Checking for suitable kernel configuration options..."
719
720 for config in ${CONFIG_CHECK}
721 do
722 # if we specify any fatal, ensure we honor them
723 die=1
724 error=0
725 negate=0
726 reworkmodulenames=0
727
728 if [[ ${config:0:1} == "~" ]]; then
729 die=0
730 config=${config:1}
731 elif [[ ${config:0:1} == "@" ]]; then
732 die=0
733 reworkmodulenames=1
734 config=${config:1}
735 fi
736 if [[ ${config:0:1} == "!" ]]; then
737 negate=1
738 config=${config:1}
739 fi
740
741 if [[ ${negate} == 1 ]]; then
742 linux_chkconfig_present ${config} && error=2
743 elif [[ ${reworkmodulenames} == 1 ]]; then
744 local temp_config="${config//*:}" i n
745 config="${config//:*}"
746 if linux_chkconfig_present ${config}; then
747 for i in ${MODULE_NAMES}; do
748 n="${i//${temp_config}}"
749 [[ -z ${n//\(*} ]] && \
750 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
751 done
752 error=2
753 fi
754 else
755 linux_chkconfig_present ${config} || error=1
756 fi
757
758 if [[ ${error} > 0 ]]; then
759 local report_func="eerror" local_error
760 local_error="ERROR_${config}"
761 local_error="${!local_error}"
762
763 if [[ -z "${local_error}" ]]; then
764 # using old, deprecated format.
765 local_error="${config}_ERROR"
766 local_error="${!local_error}"
767 fi
768 if [[ ${die} == 0 && -z "${local_error}" ]]; then
769 #soft errors can be warnings
770 local_error="WARNING_${config}"
771 local_error="${!local_error}"
772 if [[ -n "${local_error}" ]] ; then
773 report_func="ewarn"
774 fi
775 fi
776
777 if [[ -z "${local_error}" ]]; then
778 [[ ${error} == 1 ]] \
779 && local_error="is not set when it should be." \
780 || local_error="should not be set. But it is."
781 local_error="CONFIG_${config}:\t ${local_error}"
782 fi
783 if [[ ${die} == 0 ]]; then
784 ${report_func} " ${local_error}"
785 soft_errors_count=$[soft_errors_count + 1]
786 else
787 ${report_func} " ${local_error}"
788 hard_errors_count=$[hard_errors_count + 1]
789 fi
790 fi
791 done
792
793 if [[ ${hard_errors_count} > 0 ]]; then
794 eerror "Please check to make sure these options are set correctly."
795 eerror "Failure to do so may cause unexpected problems."
796 eerror "Once you have satisfied these options, please try merging"
797 eerror "this package again."
798 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
799 die "Incorrect kernel configuration options"
800 elif [[ ${soft_errors_count} > 0 ]]; then
801 ewarn "Please check to make sure these options are set correctly."
802 ewarn "Failure to do so may cause unexpected problems."
803 else
804 eend 0
805 fi
806 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
186} 807}
187 808
188check_zlibinflate() { 809check_zlibinflate() {
189 # if we haven't determined the version yet, we need too. 810 # if we haven't determined the version yet, we need to
811 require_configured_kernel
190 get_version; 812 get_version
191 813
192 # although I restructured this code - I really really really dont support it! 814 # although I restructured this code - I really really really dont support it!
193 815
194 # bug #27882 - zlib routines are only linked into the kernel 816 # bug #27882 - zlib routines are only linked into the kernel
195 # if something compiled into the kernel calls them 817 # if something compiled into the kernel calls them
196 # 818 #
197 # plus, for the cloop module, it appears that there's no way 819 # plus, for the cloop module, it appears that there's no way
198 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 820 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
199 # is on 821 # is on
200 822
201local INFLATE 823 local INFLATE
202local DEFLATE 824 local DEFLATE
203 825
204 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 826 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
205 827
206 ebegin "checking ZLIB_INFLATE" 828 ebegin "checking ZLIB_INFLATE"
207 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 829 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
208 eend $? 830 eend $?
209 [ "$?" != 0 ] && die 831 [ "$?" != 0 ] && die
210 832
211 ebegin "checking ZLIB_DEFLATE" 833 ebegin "checking ZLIB_DEFLATE"
212 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 834 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
213 eend $? 835 eend $?
214 [ "$?" != 0 ] && die 836 [ "$?" != 0 ] && die
215 837
216
217 local LINENO_START 838 local LINENO_START
218 local LINENO_END 839 local LINENO_END
219 local SYMBOLS 840 local SYMBOLS
220 local x 841 local x
221 842
222 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 843 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
223 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 844 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
224 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 845 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
225 (( LINENO_END = $LINENO_END - 1 )) 846 (( LINENO_END = $LINENO_END - 1 ))
226 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 847 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
227 848
228 # okay, now we have a list of symbols 849 # okay, now we have a list of symbols
229 # we need to check each one in turn, to see whether it is set or not 850 # we need to check each one in turn, to see whether it is set or not
230 for x in $SYMBOLS ; do 851 for x in $SYMBOLS ; do
231 if [ "${!x}" = "y" ]; then 852 if [ "${!x}" = "y" ]; then
232 # we have a winner! 853 # we have a winner!
233 einfo "${x} ensures zlib is linked into your kernel - excellent" 854 einfo "${x} ensures zlib is linked into your kernel - excellent"
234 return 0 855 return 0
235 fi 856 fi
236 done 857 done
237 858
238 eerror 859 eerror
239 eerror "This kernel module requires ZLIB library support." 860 eerror "This kernel module requires ZLIB library support."
240 eerror "You have enabled zlib support in your kernel, but haven't enabled" 861 eerror "You have enabled zlib support in your kernel, but haven't enabled"
241 eerror "enabled any option that will ensure that zlib is linked into your" 862 eerror "enabled any option that will ensure that zlib is linked into your"
242 eerror "kernel." 863 eerror "kernel."
252 eerror "Please remember to recompile and install your kernel, and reboot" 873 eerror "Please remember to recompile and install your kernel, and reboot"
253 eerror "into your new kernel before attempting to load this kernel module." 874 eerror "into your new kernel before attempting to load this kernel module."
254 875
255 die "Kernel doesn't include zlib support" 876 die "Kernel doesn't include zlib support"
256} 877}
878
879################################
880# Default pkg_setup
881# Also used when inheriting linux-mod to force a get_version call
882# @FUNCTION: linux-info_pkg_setup
883# @DESCRIPTION:
884# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
885# to support the options specified in CONFIG_CHECK (if not null)
886linux-info_pkg_setup() {
887 linux-info_get_any_version
888
889 if kernel_is 2 4; then
890 if [ "$( gcc-major-version )" -eq "4" ] ; then
891 echo
892 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
893 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
894 echo
895 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
896 ewarn "newer kernel that supports gcc-4."
897 echo
898 ewarn "Also be aware that bugreports about gcc-4 not working"
899 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
900 echo
901 epause 10
902 fi
903 fi
904
905 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
906}

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.86

  ViewVC Help
Powered by ViewVC 1.1.20